<?php
 
 
 

namespace PhpWA\Protocol\Proto\Message;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class StatusNotificationMessage extends \Google\Protobuf\Internal\Message
{
    


    protected $responseMessageKey = null;
    


    protected $originalMessageKey = null;
    


    protected $type = null;

    










    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getResponseMessageKey()
    {
        return $this->responseMessageKey;
    }

    public function hasResponseMessageKey()
    {
        return isset($this->responseMessageKey);
    }

    public function clearResponseMessageKey()
    {
        unset($this->responseMessageKey);
    }

    




    public function setResponseMessageKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageKey::class);
        $this->responseMessageKey = $var;

        return $this;
    }

    



    public function getOriginalMessageKey()
    {
        return $this->originalMessageKey;
    }

    public function hasOriginalMessageKey()
    {
        return isset($this->originalMessageKey);
    }

    public function clearOriginalMessageKey()
    {
        unset($this->originalMessageKey);
    }

    




    public function setOriginalMessageKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageKey::class);
        $this->originalMessageKey = $var;

        return $this;
    }

    



    public function getType()
    {
        return isset($this->type) ? $this->type : 0;
    }

    public function hasType()
    {
        return isset($this->type);
    }

    public function clearType()
    {
        unset($this->type);
    }

    




    public function setType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\StatusNotificationMessage\StatusNotificationType::class);
        $this->type = $var;

        return $this;
    }

}

